--- //depot/vendor/freebsd/src/sys/conf/files	2005/07/19 02:10:35
+++ //depot/user/rwatson/netperf/sys/conf/files	2005/07/19 11:47:08
@@ -1239,6 +1239,7 @@
 kern/subr_kobj.c		standard
 kern/subr_log.c			standard
 kern/subr_mbpool.c		optional libmbpool
+kern/subr_mbufqueue.c	standard
 kern/subr_mchain.c		optional libmchain
 kern/subr_module.c		standard
 kern/subr_msgbuf.c		standard
@@ -1784,6 +1785,7 @@
 security/mac_seeotheruids/mac_seeotheruids.c optional mac_seeotheruids
 security/mac_stub/mac_stub.c	optional mac_stub
 security/mac_test/mac_test.c	optional mac_test
+test/test_synch_timing.c	standard
 ufs/ffs/ffs_alloc.c		optional ffs
 ufs/ffs/ffs_balloc.c		optional ffs
 ufs/ffs/ffs_inode.c		optional ffs
--- //depot/vendor/freebsd/src/sys/dev/aic7xxx/aicasm/Makefile	2004/12/21 08:50:46
+++ //depot/user/rwatson/netperf/sys/dev/aic7xxx/aicasm/Makefile	2005/01/01 21:09:05
@@ -34,6 +34,7 @@
 CFLAGS+= -I${MAKESRCPATH}
 .endif
 NO_MAN=
+NOMAN=
 YFLAGS= -b ${.TARGET:R} ${.TARGET:M*macro*:S/$(.TARGET)/-p mm/} -d
 LFLAGS+= ${.TARGET:M*macro*:S/$(.TARGET)/-Pmm/}
 
--- //depot/vendor/freebsd/src/sys/dev/em/if_em.c	2005/06/10 16:51:34
+++ //depot/user/rwatson/netperf/sys/dev/em/if_em.c	2005/07/05 14:55:33
@@ -584,7 +584,64 @@
 	return(0);
 }
 
+/*
+ * Alternative transmit entry point: accept an mbuf as well as a network
+ * interface, avoiding queuing overhead if possible.  Several paths, depending
+ * on whether other packets are already queued or not.  We must either hand
+ * off or free the mbuf, as the caller no longer owns it.
+ *
+ * XXXRW: For now, simply replicate if_handoff(), avoiding two mutex
+ * operations, but eventually we want a fast path here with no ifq mutex
+ * operations for when the ifq is full.  I left it with one pair for now to
+ * maintain consistency on the if send counters.
+ */
+static int
+em_start_mbuf(struct ifnet *ifp, struct mbuf *m, int adjust)
+{
+	struct adapter *adapter = ifp->if_softc;
+	struct ifqueue *ifq;
+
+	/*
+	 * First, do a lot of work to make it look as though the packet was
+	 * queued by if_handoff(), stats, etc.
+	 */
+	EM_LOCK(adapter);
+	ifq = (struct ifqueue *)&ifp->if_snd;
+	IF_LOCK(ifq);
+	if (_IF_QFULL(ifq)) {
+		_IF_DROP(ifq);
+		IF_UNLOCK(ifq);
+		EM_UNLOCK(adapter);
+		m_freem(m);
+		return (0);
+	}
+	ifp->if_obytes += m->m_pkthdr.len + adjust;
+	if (m->m_flags & (M_BCAST|M_MCAST))
+		ifp->if_omcasts++;
 
+	/*
+	 * Now we see if the queue is empty, in which case we can begin a
+	 * direct dispatch of our packet.  Otherwise, we enqueue it as
+	 * if_handoff() would have.  NOTE: Not ALTQ-safe.
+	 */
+	if (IFQ_IS_EMPTY(ifq)) {
+		if (em_encap(adapter, &m))
+			goto enqueue;
+		ifp->if_flags |= IFF_OACTIVE;
+		BPF_MTAP(ifp, m);
+		ifp->if_timer = EM_TX_TIMEOUT;
+		IF_UNLOCK(ifq);
+		EM_UNLOCK(adapter);
+		return (1);
+	}
+enqueue:
+	if (m != NULL)
+		_IF_ENQUEUE(ifq, m);
+	IF_UNLOCK(ifq);
+	EM_UNLOCK(adapter);
+	return (1);
+}
+
 /*********************************************************************
  *  Transmit entry point
  *
@@ -1940,6 +1997,7 @@
 	ifp->if_flags = IFF_BROADCAST | IFF_SIMPLEX | IFF_MULTICAST;
 	ifp->if_ioctl = em_ioctl;
 	ifp->if_start = em_start;
+	ifp->if_start_mbuf = em_start_mbuf;
 	ifp->if_watchdog = em_watchdog;
 	IFQ_SET_MAXLEN(&ifp->if_snd, adapter->num_tx_desc - 1);
 	ifp->if_snd.ifq_drv_maxlen = adapter->num_tx_desc - 1;
--- //depot/vendor/freebsd/src/sys/dev/fdc/fdc_isa.c	2005/03/15 08:07:19
+++ //depot/user/rwatson/netperf/sys/dev/fdc/fdc_isa.c	2005/06/01 10:10:04
@@ -78,15 +78,14 @@
 fdc_isa_alloc_resources(device_t dev, struct fdc_data *fdc)
 {
 	struct resource *res;
-	int i, j, rid, newrid, nport;
-	u_long port;
+	int nports = 6;
+	int i, j, rid, newrid;
 
 	fdc->fdc_dev = dev;
 	rid = 0;
 	for (i = 0; i < FDC_MAXREG; i++)
 		fdc->resio[i] = NULL;
 
-	nport = isa_get_logicalid(dev) ? 1 : 6;
 	for (rid = 0; ; rid++) {
 		newrid = rid;
 		res = bus_alloc_resource(dev, SYS_RES_IOPORT, &newrid,
@@ -109,28 +108,15 @@
 			fdc->ioh[i + j] = rman_get_bushandle(res);
 		}
 	}
-	if (fdc->resio[2] == NULL) {
-		device_printf(dev, "No FDOUT register!\n");
+	if (fdc->resio[2] == NULL)
 		return (ENXIO);
-	}
 	fdc->iot = rman_get_bustag(fdc->resio[2]);
 	if (fdc->resio[7] == NULL) {
-		port = (rman_get_start(fdc->resio[2]) & ~0x7) + 7;
-		newrid = rid;
-		res = bus_alloc_resource(dev, SYS_RES_IOPORT, &newrid, port,
-		    port, 1, RF_ACTIVE);
-		if (res == NULL) {
-			device_printf(dev, "Faking up FDCTL\n");
-			fdc->resio[7] = fdc->resio[2];
-			fdc->ridio[7] = fdc->ridio[2];
-			fdc->ioff[7] = fdc->ioff[2] + 5;
-			fdc->ioh[7] = fdc->ioh[2];
-		} else {
-			fdc->resio[7] = res;
-			fdc->ridio[7] = newrid;
-			fdc->ioff[7] = rman_get_start(res) & 7;
-			fdc->ioh[7] = rman_get_bushandle(res);
-		}
+		/* XXX allocate */
+		fdc->resio[7] = fdc->resio[2];
+		fdc->ridio[7] = fdc->ridio[2];
+		fdc->ioff[7] = fdc->ioff[2] + 5;
+		fdc->ioh[7] = fdc->ioh[2];
 	}
 
 	fdc->res_irq = bus_alloc_resource_any(dev, SYS_RES_IRQ, &fdc->rid_irq,
--- //depot/vendor/freebsd/src/sys/dev/random/randomdev_soft.c	2005/03/29 11:10:26
+++ //depot/user/rwatson/netperf/sys/dev/random/randomdev_soft.c	2005/06/01 10:10:04
@@ -53,7 +53,7 @@
 #include <dev/random/randomdev.h>
 #include <dev/random/randomdev_soft.h>
 
-#define RANDOM_FIFO_MAX	256	/* How many events to queue up */
+#define RANDOM_FIFO_MAX	4	/* How many events to queue up */
 
 static void random_kthread(void *);
 static void 
--- //depot/vendor/freebsd/src/sys/fs/portalfs/portal_vnops.c	2005/03/28 09:35:18
+++ //depot/user/rwatson/netperf/sys/fs/portalfs/portal_vnops.c	2005/06/01 10:10:04
@@ -188,6 +188,7 @@
 
 	unp2 = sotounpcb(so2);
 	unp3 = sotounpcb(so3);
+	/* XXXRW: Locking? */
 	if (unp2->unp_addr)
 		unp3->unp_addr = (struct sockaddr_un *)
 		    sodupsockaddr((struct sockaddr *)unp2->unp_addr,
--- //depot/vendor/freebsd/src/sys/i386/conf/GENERIC	2005/07/14 15:40:25
+++ //depot/user/rwatson/netperf/sys/i386/conf/GENERIC	2005/07/19 11:47:08
@@ -71,6 +71,7 @@
 options 	INVARIANT_SUPPORT	# Extra sanity checks of internal structures, required by INVARIANTS
 options 	WITNESS			# Enable checks to detect deadlocks and cycles
 options 	WITNESS_SKIPSPIN	# Don't run witness on spinlocks for speed
+options 	BREAK_TO_DEBUGGER
 
 # To make an SMP kernel, the next two lines are needed
 options 	SMP			# Symmetric MultiProcessor Kernel
--- //depot/vendor/freebsd/src/sys/kern/kern_descrip.c	2005/06/25 03:35:21
+++ //depot/user/rwatson/netperf/sys/kern/kern_descrip.c	2005/07/05 14:55:33
@@ -1517,6 +1517,9 @@
 
 /*
  * Release a filedesc structure.
+ *
+ * XXXRW: Requires Giant because it calls into VFS.  Status of p_fdtol is
+ * unclear to me.
  */
 void
 fdfree(struct thread *td)
@@ -1656,10 +1659,16 @@
  *
  * Since setugidsafety calls this only for fd 0, 1 and 2, this check is
  * sufficient.  We also don't check for setugidness since we know we are.
+ *
+ * XXXRW: Requires Giant due to check of v_vflag.  Actually, this can
+ * probably become a lockless read.
  */
 static int
 is_unsafe(struct file *fp)
 {
+
+	GIANT_REQUIRED;
+
 	if (fp->f_type == DTYPE_VNODE) {
 		struct vnode *vp = fp->f_vnode;
 
@@ -1671,6 +1680,8 @@
 
 /*
  * Make this setguid thing safe, if at all possible.
+ *
+ * XXXRW: MPSAFE, as knote_fdclose() and closef() are both now MPSAFE.
  */
 void
 setugidsafety(struct thread *td)
@@ -1728,6 +1739,8 @@
 
 /*
  * Close any files on exec?
+ *
+ * XXXRW: Now MPSAFE, as knode_fdclosed() and closef() are now MPSAFE.
  */
 void
 fdcloseexec(struct thread *td)
@@ -1774,6 +1787,8 @@
  * significance in the Standard C library.  fdcheckstd() will create a
  * descriptor referencing /dev/null for each of stdin, stdout, and
  * stderr that is not already open.
+ *
+ * XXXRW: Requires Giant for VFS access.  do_dup is MPSAFE.
  */
 int
 fdcheckstd(struct thread *td)
@@ -2000,6 +2015,7 @@
  * but never have VM objects.  The returned vnode will be vref()d.
  *
  * XXX: what about the unused flags ?
+ * XXXRW: _fgetvp() is not MPSAFE because of VFS access.
  */
 static __inline int
 _fgetvp(struct thread *td, int fd, struct vnode **vpp, int flags)
@@ -2049,6 +2065,8 @@
  *
  * We bump the ref count on the returned socket.  XXX Also obtain the SX
  * lock in the future.
+ * 
+ * XXXRW: fgetsock() is MPSAFE.
  */
 int
 fgetsock(struct thread *td, int fd, struct socket **spp, u_int *fflagp)
@@ -2103,6 +2121,9 @@
  * Drop reference on struct file passed in, may call closef if the
  * reference hits zero.
  * Expects struct file locked, and will unlock it.
+ *
+ * XXXRW: fdrop_locked() is MPSAFE, as fo_close() will acquire Giant if it
+ * needs it.
  */
 static int
 fdrop_locked(struct file *fp, struct thread *td)
--- //depot/vendor/freebsd/src/sys/kern/kern_poll.c	2005/02/25 22:10:33
+++ //depot/user/rwatson/netperf/sys/kern/kern_poll.c	2005/02/27 16:23:38
@@ -31,6 +31,8 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/kernel.h>
+#include <sys/lock.h>
+#include <sys/mutex.h>
 #include <sys/socket.h>			/* needed by net/if.h		*/
 #include <sys/sysctl.h>
 
@@ -177,12 +179,15 @@
 
 static struct pollrec pr[POLL_LIST_LEN];
 
+static struct mtx pollmtx;
+
 static void
 init_device_poll(void)
 {
 
-	netisr_register(NETISR_POLL, (netisr_t *)netisr_poll, NULL, 0);
-	netisr_register(NETISR_POLLMORE, (netisr_t *)netisr_pollmore, NULL, 0);
+	mtx_init(&pollmtx, "pollmtx", NULL, MTX_DEF);
+	netisr_register(NETISR_POLL, (netisr_t *)netisr_poll, NULL, NETISR_MPSAFE);
+	netisr_register(NETISR_POLLMORE, (netisr_t *)netisr_pollmore, NULL, NETISR_MPSAFE);
 }
 SYSINIT(device_poll, SI_SUB_CLOCKS, SI_ORDER_MIDDLE, init_device_poll, NULL)
 
@@ -209,6 +214,7 @@
 	if (poll_handlers == 0)
 		return;
 
+	mtx_lock(&pollmtx);
 	microuptime(&t);
 	delta = (t.tv_usec - prev_t.tv_usec) +
 		(t.tv_sec - prev_t.tv_sec)*1000000;
@@ -236,6 +242,7 @@
 	}
 	if (pending_polls++ > 0)
 		lost_polls++;
+	mtx_unlock(&pollmtx);
 }
 
 /*
@@ -246,15 +253,14 @@
 {
 	int i;
 
-	mtx_lock(&Giant);
-
+	mtx_lock(&pollmtx);
 	if (count > poll_each_burst)
 		count = poll_each_burst;
 	for (i = 0 ; i < poll_handlers ; i++)
 		if (pr[i].handler && (IFF_UP|IFF_RUNNING) ==
 		    (pr[i].ifp->if_flags & (IFF_UP|IFF_RUNNING)) )
 			pr[i].handler(pr[i].ifp, 0, count); /* quick check */
-	mtx_unlock(&Giant);
+	mtx_unlock(&pollmtx);
 }
 
 /*
@@ -280,8 +286,8 @@
 {
 	struct timeval t;
 	int kern_load;
-	/* XXX run at splhigh() or equivalent */
 
+	mtx_lock(&pollmtx);
 	phase = 5;
 	if (residual_burst > 0) {
 		schednetisrbits(1 << NETISR_POLL | 1 << NETISR_POLLMORE);
@@ -316,6 +322,7 @@
 		schednetisrbits(1 << NETISR_POLL | 1 << NETISR_POLLMORE);
 		phase = 6;
 	}
+	mtx_unlock(&pollmtx);
 }
 
 /*
@@ -329,8 +336,8 @@
 	static int reg_frac_count;
 	int i, cycles;
 	enum poll_cmd arg = POLL_ONLY;
-	mtx_lock(&Giant);
 
+	mtx_lock(&pollmtx);
 	phase = 3;
 	if (residual_burst == 0) { /* first call in this tick */
 		microuptime(&poll_start_t);
@@ -390,7 +397,7 @@
 	}
 	/* on -stable, schednetisr(NETISR_POLLMORE); */
 	phase = 4;
-	mtx_unlock(&Giant);
+	mtx_unlock(&pollmtx);
 }
 
 /*
@@ -404,7 +411,6 @@
 int
 ether_poll_register(poll_handler_t *h, struct ifnet *ifp)
 {
-	int s;
 
 	if (polling == 0) /* polling disabled, cannot register */
 		return 0;
@@ -415,7 +421,7 @@
 	if (ifp->if_flags & IFF_POLLING)	/* already polling	*/
 		return 0;
 
-	s = splhigh();
+	mtx_lock(&pollmtx);
 	if (poll_handlers >= POLL_LIST_LEN) {
 		/*
 		 * List full, cannot register more entries.
@@ -425,7 +431,7 @@
 		 * anyways, so just report a few times and then give up.
 		 */
 		static int verbose = 10 ;
-		splx(s);
+		mtx_unlock(&pollmtx);
 		if (verbose >0) {
 			printf("poll handlers list full, "
 				"maybe a broken driver ?\n");
@@ -438,9 +444,9 @@
 	pr[poll_handlers].ifp = ifp;
 	poll_handlers++;
 	ifp->if_flags |= IFF_POLLING;
-	splx(s);
 	if (idlepoll_sleeping)
 		wakeup(&idlepoll_sleeping);
+	mtx_unlock(&pollmtx);
 	return 1; /* polling enabled in next call */
 }
 
@@ -455,9 +461,9 @@
 {
 	int i;
 
-	mtx_lock(&Giant);
+	mtx_lock(&pollmtx);
 	if ( !ifp || !(ifp->if_flags & IFF_POLLING) ) {
-		mtx_unlock(&Giant);
+		mtx_unlock(&pollmtx);
 		return 0;
 	}
 	for (i = 0 ; i < poll_handlers ; i++)
@@ -465,7 +471,7 @@
 			break;
 	ifp->if_flags &= ~IFF_POLLING; /* found or not... */
 	if (i == poll_handlers) {
-		mtx_unlock(&Giant);
+		mtx_unlock(&pollmtx);
 		printf("ether_poll_deregister: ifp not found!!!\n");
 		return 0;
 	}
@@ -474,7 +480,7 @@
 		pr[i].handler = pr[poll_handlers].handler;
 		pr[i].ifp = pr[poll_handlers].ifp;
 	}
-	mtx_unlock(&Giant);
+	mtx_unlock(&pollmtx);
 	return 1;
 }
 
@@ -492,21 +498,24 @@
 	pri = td->td_priority;
 	mtx_unlock_spin(&sched_lock);
 
+	mtx_lock(&pollmtx);
 	for (;;) {
 		if (poll_in_idle_loop && poll_handlers > 0) {
 			idlepoll_sleeping = 0;
-			mtx_lock(&Giant);
 			ether_poll(poll_each_burst);
-			mtx_unlock(&Giant);
 			mtx_assert(&Giant, MA_NOTOWNED);
+			mtx_unlock(&pollmtx);
 			mtx_lock_spin(&sched_lock);
 			mi_switch(SW_VOL, NULL);
 			mtx_unlock_spin(&sched_lock);
+			mtx_lock(&pollmtx);
 		} else {
 			idlepoll_sleeping = 1;
-			tsleep(&idlepoll_sleeping, pri, "pollid", hz * 3);
+			msleep(&idlepoll_sleeping, &pollmtx, pri, "pollid",
+			    hz * 3);
 		}
 	}
+	mtx_unlock(&pollmtx);
 }
 
 static struct proc *idlepoll;
--- //depot/vendor/freebsd/src/sys/kern/subr_log.c	2005/02/27 22:05:29
+++ //depot/user/rwatson/netperf/sys/kern/subr_log.c	2005/03/12 17:40:56
@@ -81,7 +81,12 @@
 	struct	callout sc_callout;	/* callout to wakeup syslog  */
 } logsoftc;
 
-int	log_open;			/* also used in log() */
+/*
+ * log_mtx protects logsoftc, log_open.  Note that log_mtx does *not*
+ * protect the structures associated with msgbuf, which require Giant.
+ */
+struct mtx	log_mtx;
+int		log_open;		/* also used in log() */
 
 /* Times per second to check for a pending syslog wakeup. */
 static int	log_wakeups_per_second = 5;
@@ -92,17 +97,24 @@
 static	int
 logopen(struct cdev *dev, int flags, int mode, struct thread *td)
 {
-	if (log_open)
+
+	mtx_lock(&log_mtx);
+	if (log_open) {
+		mtx_unlock(&log_mtx);
 		return (EBUSY);
+	}
 	log_open = 1;
-	callout_init(&logsoftc.sc_callout, 0);
+	callout_init(&logsoftc.sc_callout, CALLOUT_MPSAFE);
+	mtx_unlock(&log_mtx);
 	fsetown(td->td_proc->p_pid, &logsoftc.sc_sigio);	/* signal process only */
+	mtx_lock(&log_mtx);
 	if (log_wakeups_per_second < 1) {
 		printf("syslog wakeup is less than one.  Adjusting to 1.\n");
 		log_wakeups_per_second = 1;
 	}
 	callout_reset(&logsoftc.sc_callout, hz / log_wakeups_per_second,
 	    logtimeout, NULL);
+	mtx_unlock(&log_mtx);
 	return (0);
 }
 
@@ -111,9 +123,11 @@
 logclose(struct cdev *dev, int flag, int mode, struct thread *td)
 {
 
+	mtx_lock(&log_mtx);
 	log_open = 0;
 	callout_stop(&logsoftc.sc_callout);
 	logsoftc.sc_state = 0;
+	mtx_unlock(&log_mtx);
 	funsetown(&logsoftc.sc_sigio);
 	return (0);
 }
@@ -132,14 +146,18 @@
 			splx(s);
 			return (EWOULDBLOCK);
 		}
+		mtx_lock(&log_mtx);
 		logsoftc.sc_state |= LOG_RDWAIT;
+		mtx_unlock(&log_mtx);
 		if ((error = tsleep(mbp, LOG_RDPRI | PCATCH, "klog", 0))) {
 			splx(s);
 			return (error);
 		}
 	}
 	splx(s);
+	mtx_lock(&log_mtx);
 	logsoftc.sc_state &= ~LOG_RDWAIT;
+	mtx_unlock(&log_mtx);
 
 	while (uio->uio_resid > 0) {
 		l = imin(sizeof(buf), uio->uio_resid);
@@ -176,8 +194,11 @@
 logtimeout(void *arg)
 {
 
-	if (!log_open)
+	mtx_lock(&log_mtx);
+	if (!log_open) {
+		mtx_unlock(&log_mtx);
 		return;
+	}
 	if (log_wakeups_per_second < 1) {
 		printf("syslog wakeup is less than one.  Adjusting to 1.\n");
 		log_wakeups_per_second = 1;
@@ -185,6 +206,7 @@
 	if (msgbuftrigger == 0) {
 		callout_reset(&logsoftc.sc_callout,
 		    hz / log_wakeups_per_second, logtimeout, NULL);
+		mtx_unlock(&log_mtx);
 		return;
 	}
 	msgbuftrigger = 0;
@@ -197,6 +219,7 @@
 	}
 	callout_reset(&logsoftc.sc_callout, hz / log_wakeups_per_second,
 	    logtimeout, NULL);
+	mtx_unlock(&log_mtx);
 }
 
 /*ARGSUSED*/
@@ -215,10 +238,12 @@
 		break;
 
 	case FIOASYNC:
+		mtx_lock(&log_mtx);
 		if (*(int *)data)
 			logsoftc.sc_state |= LOG_ASYNC;
 		else
 			logsoftc.sc_state &= ~LOG_ASYNC;
+		mtx_unlock(&log_mtx);
 		break;
 
 	case FIOSETOWN:
@@ -247,6 +272,7 @@
 log_drvinit(void *unused)
 {
 
+	mtx_init(&log_mtx, "log_mtx", NULL, MTX_DEF);
 	make_dev(&log_cdevsw, 0, UID_ROOT, GID_WHEEL, 0600, "klog");
 }
 
--- //depot/vendor/freebsd/src/sys/kern/subr_prf.c	2005/06/06 22:21:14
+++ //depot/user/rwatson/netperf/sys/kern/subr_prf.c	2005/07/05 14:55:33
@@ -84,6 +84,9 @@
 	size_t	remain;
 };
 
+/*
+ * XXXRW: We access subr_log.c's log_open variable unlocked.
+ */
 extern	int log_open;
 
 static void  msglogchar(int c, int pri);
--- //depot/vendor/freebsd/src/sys/kern/subr_witness.c	2005/06/04 23:25:18
+++ //depot/user/rwatson/netperf/sys/kern/subr_witness.c	2005/07/05 14:55:33
@@ -316,6 +316,7 @@
 	 */
 	{ "ddp_list_mtx", &lock_class_mtx_sleep },
 	{ "ddp_mtx", &lock_class_mtx_sleep },
+	{ "at_ifaddr", &lock_class_mtx_sleep },
 	{ NULL, NULL },
 	/*
 	 * BPF
--- //depot/vendor/freebsd/src/sys/kern/sys_pipe.c	2005/07/01 16:35:11
+++ //depot/user/rwatson/netperf/sys/kern/sys_pipe.c	2005/07/05 14:55:33
@@ -414,6 +414,9 @@
  * This routine will 'realloc' the size of a pipe safely, if it fails
  * it will retain the old buffer.
  * If it fails it will return ENOMEM.
+ *
+ * This version of the call should not be called directly except via
+ * pipe_create(), as it doesn't assert the pipe lock.
  */
 static int
 pipespace_new(cpipe, size)
--- //depot/vendor/freebsd/src/sys/kern/uipc_socket.c	2005/07/01 16:35:11
+++ //depot/user/rwatson/netperf/sys/kern/uipc_socket.c	2005/07/05 14:55:33
@@ -347,6 +347,7 @@
 	ACCEPT_LOCK_ASSERT();
 	SOCK_LOCK_ASSERT(so);
 
+	/* XXXRW: Why would SS_NOFDREF be unset here?  so_count is 0. */
 	if (so->so_pcb != NULL || (so->so_state & SS_NOFDREF) == 0 ||
 	    so->so_count != 0) {
 		SOCK_UNLOCK(so);
@@ -409,6 +410,45 @@
 	sodealloc(so);
 }
 
+#if 0
+static void
+dump_socket(struct socket *so)
+{
+
+	printf("so = %p\n", so);
+	printf("  so_count = %d\n", so->so_count);
+	printf("  so_type = %d\n", so->so_type);
+	printf("  so_options = %d\n", so->so_options);
+	printf("  so_linger = %d\n", so->so_linger);
+	printf("  so_state = %d\n", so->so_state);
+	printf("  so_qstate = %d\n", so->so_qstate);
+	printf("  so_pcb = %p\n", so->so_pcb);
+	printf("  so_proto = %p\n", so->so_proto);
+	printf("    pr_type = %d\n", so->so_proto->pr_type);
+	printf("    pr_domain = %p\n", so->so_proto->pr_domain);
+	printf("      dom_family = %d\n", so->so_proto->pr_domain->dom_family);
+	printf("      dom_name = %s\n", so->so_proto->pr_domain->dom_name);
+	printf("    pr_protocol = %d\n", so->so_proto->pr_protocol);
+	printf("    pr_flags = %d\n", so->so_proto->pr_flags);
+	printf("  so_head = %p\n", so->so_head);
+	printf("  TAILQ_FIRST(so_incomp) = %p\n", TAILQ_FIRST(&so->so_incomp));
+	printf("  TAILQ_FIRST(so_comp) = %p\n", TAILQ_FIRST(&so->so_comp));
+	printf("  so_qlen = %d\n", so->so_qlen);
+	printf("  so_incqlen = %d\n", so->so_incqlen);
+	printf("  so_qlimit = %d\n", so->so_qlimit);
+	printf("  so_timeo = %d\n", so->so_timeo);
+	printf("  so_error = %d\n", so->so_error);
+	printf("  so_sigio = %p\n", so->so_sigio);
+	printf("  so_oobmark = %lu\n", so->so_oobmark);
+	printf("  so_rcv.sb_state = %d\n", so->so_rcv.sb_state);
+	printf("  so_snd.sb_state = %d\n", so->so_snd.sb_state);
+	printf("  so_upcall = %p\n", so->so_upcall);
+	printf("  so_upcallarg = %p\n", so->so_upcallarg);
+	printf("  so_cred = %p\n", so->so_cred);
+	printf("  so_gencnt = %d\n", (int)so->so_gencnt);
+}
+#endif
+
 /*
  * Close a socket on last file table reference removal.
  * Initiate disconnect if connected.
@@ -427,6 +467,23 @@
 	KASSERT(!(so->so_state & SS_NOFDREF), ("soclose: SS_NOFDREF on enter"));
 
 	funsetown(&so->so_sigio);
+	/*-
+	 * XXXRW: Lots of locking problems here.  For one thing,
+	 * we should probably clear the SO_ACCEPTCONN flag and
+	 * push that down to the protocol layer.  Also, the locking
+	 * for the queue draining is probably not right either:
+	 * what prevents new ones from being inserted after we get
+	 * past this?  Ideally, the downcall would prevent this, but
+	 * there isn't one.
+	 */
+	/*
+	 * XXXRW: soclose() should be split into two parts: one to handle
+	 * listen sockets, and the other to handle the remainder.  To
+	 * prevent races with the protocol code, we need to detach before
+	 * draining the queues.  For non-listen sockets, the disconnect
+	 * has to happen before the detach.
+	 */
+	/* Unlocked read. */
 	if (so->so_options & SO_ACCEPTCONN) {
 		struct socket *sp;
 		ACCEPT_LOCK();
@@ -452,6 +509,7 @@
 	}
 	if (so->so_pcb == NULL)
 		goto discard;
+	/* XXXRW: so_state locking? */
 	if (so->so_state & SS_ISCONNECTED) {
 		if ((so->so_state & SS_ISDISCONNECTING) == 0) {
 			error = sodisconnect(so);
@@ -538,6 +596,7 @@
 	 * This allows user to disconnect by connecting to, e.g.,
 	 * a null address.
 	 */
+	/* Unlocked read. */
 	if (so->so_state & (SS_ISCONNECTED|SS_ISCONNECTING) &&
 	    ((so->so_proto->pr_flags & PR_CONNREQUIRED) ||
 	    (error = sodisconnect(so)))) {
@@ -569,6 +628,7 @@
 {
 	int error;
 
+	/* Unlocked read. */
 	if ((so->so_state & SS_ISCONNECTED) == 0)
 		return (ENOTCONN);
 	if (so->so_state & SS_ISDISCONNECTING)
@@ -659,8 +719,6 @@
 #define	snderr(errno)	{ error = (errno); goto release; }
 
 	SOCKBUF_LOCK(&so->so_snd);
-restart:
-	SOCKBUF_LOCK_ASSERT(&so->so_snd);
 	error = sblock(&so->so_snd, SBLOCKWAIT(flags));
 	if (error)
 		goto out_locked;
@@ -699,11 +757,10 @@
 		    (atomic || space < so->so_snd.sb_lowat || space < clen)) {
 			if ((so->so_state & SS_NBIO) || (flags & MSG_NBIO))
 				snderr(EWOULDBLOCK);
-			sbunlock(&so->so_snd);
 			error = sbwait(&so->so_snd);
 			if (error)
-				goto out_locked;
-			goto restart;
+				goto release;
+			continue;
 		}
 		SOCKBUF_UNLOCK(&so->so_snd);
 		mp = &top;
@@ -812,6 +869,15 @@
 				break;
 			}
 		    } while (space > 0 && atomic);
+		    /*
+		     * XXXRW: There may be a race condition here regarding
+		     * SO_DONTROUTE.  We hold the sblock() so in theory
+		     * there won't be other consumers of the socket doing
+		     * a pru_send(), but SO_DONTROUTE is also consumed
+		     * from the protocol side.  It sounds like we might
+		     * want to use MSG_DONTROUTE here, if the semantics are
+		     * right.
+		     */
 		    if (dontroute) {
 			    SOCK_LOCK(so);
 			    so->so_options |= SO_DONTROUTE;
@@ -840,6 +906,10 @@
 			/* If there is more to send set PRUS_MORETOCOME */
 			(resid > 0 && space > 0) ? PRUS_MORETOCOME : 0,
 			top, addr, control, td);
+		    /*
+		     * XXXRW: Second half of above comment on SO_DONTROUTE.
+		     * and so_options.
+		     */
 		    if (dontroute) {
 			    SOCK_LOCK(so);
 			    so->so_options &= ~SO_DONTROUTE;
@@ -1004,17 +1074,18 @@
 		return (soreceive_rcvoob(so, uio, flags));
 	if (mp != NULL)
 		*mp = NULL;
+	/* Unlocked read. */
 	if ((pr->pr_flags & PR_WANTRCVD) && (so->so_state & SS_ISCONFIRMING)
 	    && uio->uio_resid)
 		(*pr->pr_usrreqs->pru_rcvd)(so, 0);
 
 	SOCKBUF_LOCK(&so->so_rcv);
-restart:
-	SOCKBUF_LOCK_ASSERT(&so->so_rcv);
 	error = sblock(&so->so_rcv, SBLOCKWAIT(flags));
 	if (error)
 		goto out;
 
+restart:
+	SOCKBUF_LOCK_ASSERT(&so->so_rcv);
 	m = so->so_rcv.sb_mb;
 	/*
 	 * If we have less data than requested, block awaiting more
@@ -1055,6 +1126,7 @@
 				m = so->so_rcv.sb_mb;
 				goto dontblock;
 			}
+		/* XXXRW: so_state locking? */
 		if ((so->so_state & (SS_ISCONNECTED|SS_ISCONNECTING)) == 0 &&
 		    (so->so_proto->pr_flags & PR_CONNREQUIRED)) {
 			error = ENOTCONN;
@@ -1062,6 +1134,7 @@
 		}
 		if (uio->uio_resid == 0)
 			goto release;
+		/* XXXRW: so_state locking? */
 		if ((so->so_state & SS_NBIO) ||
 		    (flags & (MSG_DONTWAIT|MSG_NBIO))) {
 			error = EWOULDBLOCK;
@@ -1069,10 +1142,9 @@
 		}
 		SBLASTRECORDCHK(&so->so_rcv);
 		SBLASTMBUFCHK(&so->so_rcv);
-		sbunlock(&so->so_rcv);
 		error = sbwait(&so->so_rcv);
 		if (error)
-			goto out;
+			goto release;
 		goto restart;
 	}
 dontblock:
@@ -1101,10 +1173,25 @@
 	if (pr->pr_flags & PR_ADDR) {
 		KASSERT(m->m_type == MT_SONAME,
 		    ("m->m_type == %d", m->m_type));
-		orig_resid = 0;
-		if (psa != NULL)
+		if (psa != NULL) {
 			*psa = sodupsockaddr(mtod(m, struct sockaddr *),
 			    M_NOWAIT);
+			if (*psa == NULL) {
+				error = ENOMEM;
+				goto release;
+			}
+			/*
+			 * XXXRW: In the rwatson_netperf branch, we don't
+			 * release the socket buffer lock here because
+			 * we always use M_NOWAIT.  In the main tree,
+			 * or if we restore conditional waiting, we
+			 * need to refresh nextpacket from the socket
+			 * buffer version of the head mbuf, or we may
+			 * have a stale value if it was previously NULL
+			 * and now isn't.
+			 */
+			nextrecord = m->m_nextpkt;
+		}
 		if (flags & MSG_PEEK) {
 			m = m->m_next;
 		} else {
@@ -1113,6 +1200,7 @@
 			m = so->so_rcv.sb_mb;
 			sockbuf_pushsync(&so->so_rcv, nextrecord);
 		}
+		orig_resid = 0;
 	}
 
 	/*
@@ -1127,6 +1215,14 @@
 
 		do {
 			if (flags & MSG_PEEK) {
+				/*
+				 * XXXRW: In the BSD/OS version of this
+				 * code, m_copym() is called with M_TRYWAIT,
+				 * and we catch allcation failures and
+				 * jump to release with error of ENOBUFS.
+				 * For consistency with the current
+				 * implementation, we don't.
+				 */
 				if (controlp != NULL) {
 					*controlp = m_copy(m, 0, m->m_len);
 					controlp = &(*controlp)->m_next;
@@ -1141,6 +1237,12 @@
 				m = so->so_rcv.sb_mb;
 			}
 		} while (m != NULL && m->m_type == MT_CONTROL);
+		/*
+		 * XXXRW: Since we're dropping the socket buffer locks, and
+		 * may have modified the mbuf list on the socket buffer, push
+		 * out the latest version so it can be seen by any other code
+		 * that accesses the buffer in the mean time.
+		 */
 		if ((flags & MSG_PEEK) == 0)
 			sockbuf_pushsync(&so->so_rcv, nextrecord);
 		while (cm != NULL) {
@@ -1162,10 +1264,21 @@
 			}
 			cm = cmn;
 		}
+		/*
+		 * XXXRW: During externalization, additional mbuf chains
+		 * may have been added to the socket buffer.  Update our
+		 * local cache to avoid using a stale value and corrupting
+		 * the list.
+		 */
 		nextrecord = so->so_rcv.sb_mb->m_nextpkt;
 		orig_resid = 0;
 	}
 	if (m != NULL) {
+		/*
+		 * XXXRW: Before the advent of sockbuf_pushsync() above, it
+		 * was necessary to do the equivilent work here.  Now, we
+		 * just assert that it is the case.
+		 */
 		if ((flags & MSG_PEEK) == 0) {
 			KASSERT(m->m_nextpkt == nextrecord,
 			    ("soreceive: post-control, nextrecord !sync"));
@@ -1180,6 +1293,11 @@
 		if (type == MT_OOBDATA)
 			flags |= MSG_OOB;
 	} else {
+		/*
+		 * XXXRW: Before the advent of sockbuf_pushsync() above, it
+		 * was necessary to update sb_mb to nextrecord here.  Now, we
+		 * just assert that is the case.
+		 */
 		if ((flags & MSG_PEEK) == 0) {
 			KASSERT(so->so_rcv.sb_mb == nextrecord,
 			    ("soreceive: sb_mb != nextrecord"));
@@ -1276,14 +1394,7 @@
 					so->so_rcv.sb_mb = m_free(m);
 					m = so->so_rcv.sb_mb;
 				}
-				if (m != NULL) {
-					m->m_nextpkt = nextrecord;
-					if (nextrecord == NULL)
-						so->so_rcv.sb_lastrecord = m;
-				} else {
-					so->so_rcv.sb_mb = nextrecord;
-					SB_EMPTY_FIXUP(&so->so_rcv);
-				}
+				sockbuf_pushsync(&so->so_rcv, nextrecord);
 				SBLASTRECORDCHK(&so->so_rcv);
 				SBLASTMBUFCHK(&so->so_rcv);
 			}
@@ -1350,6 +1461,12 @@
 			/*
 			 * Notify the protocol that some data has been
 			 * drained before blocking.
+			 *
+			 * XXXRW: We drop the socket buffer lock here
+			 * because we know the protocol will need to do its
+			 * own locking.  However, after calling pru_rcvd()
+			 * and re-grabbing the buffer mutex, we don't
+			 * re-check the condition before sleeping.
 			 */
 			if (pr->pr_flags & PR_WANTRCVD && so->so_pcb != NULL) {
 				SOCKBUF_UNLOCK(&so->so_rcv);
@@ -1359,8 +1476,10 @@
 			SBLASTRECORDCHK(&so->so_rcv);
 			SBLASTMBUFCHK(&so->so_rcv);
 			error = sbwait(&so->so_rcv);
-			if (error)
+			if (error) {
+				error = 0;
 				goto release;
+			}
 			m = so->so_rcv.sb_mb;
 			if (m != NULL)
 				nextrecord = m->m_nextpkt;
@@ -1393,6 +1512,10 @@
 		 * If soreceive() is being done from the socket callback, then 
 		 * don't need to generate ACK to peer to update window, since 
 		 * ACK will be generated on return to TCP.
+		 *
+		 * XXXRW: We drop the socket buffer lock before calling
+		 * down into the protocol.  Is that OK in the calling
+		 * context?
 		 */
 		if (!(flags & MSG_SOCALLBCK) && 
 		    (pr->pr_flags & PR_WANTRCVD) && so->so_pcb) {
@@ -1403,10 +1526,8 @@
 	}
 	SOCKBUF_LOCK_ASSERT(&so->so_rcv);
 	if (orig_resid == uio->uio_resid && orig_resid &&
-	    (flags & MSG_EOR) == 0 && (so->so_rcv.sb_state & SBS_CANTRCVMORE) == 0) {
-		sbunlock(&so->so_rcv);
-		goto restart;
-	}
+	    (flags & MSG_EOR) == 0 && (so->so_rcv.sb_state & SBS_CANTRCVMORE) == 0)
+		goto restart;		/* XXX multi-counts msgs */
 
 	if (flagsp != NULL)
 		*flagsp |= flags;
@@ -1474,6 +1595,7 @@
 	    sizeof(*sb) - offsetof(struct sockbuf, sb_startzero));
 	SOCKBUF_UNLOCK(sb);
 
+	/* XXXRW: is passing in sb_mb this way really safe? */
 	SOCKBUF_LOCK_INIT(&asb, "so_rcv");
 	if (pr->pr_flags & PR_RIGHTS && pr->pr_domain->dom_dispose != NULL)
 		(*pr->pr_domain->dom_dispose)(asb.sb_mb);
@@ -1781,6 +1903,7 @@
 		case SO_TIMESTAMP:
 		case SO_BINTIME:
 		case SO_NOSIGPIPE:
+			/* Unlocked read. */
 			optval = so->so_options & sopt->sopt_name;
 integer:
 			error = sooptcopyout(sopt, &optval, sizeof optval);
@@ -1986,6 +2109,10 @@
 {
 	int revents = 0;
 
+	/*
+	 * XXXRW: We can probably trim this down to acquire only one lock at
+	 * a time, and do it conditional on (events).
+	 */
 	SOCKBUF_LOCK(&so->so_snd);
 	SOCKBUF_LOCK(&so->so_rcv);
 	if (events & (POLLIN | POLLRDNORM))
@@ -2032,6 +2159,7 @@
 
 	switch (kn->kn_filter) {
 	case EVFILT_READ:
+		/* Unlocked read. */
 		if (so->so_options & SO_ACCEPTCONN)
 			kn->kn_fop = &solisten_filtops;
 		else
@@ -2129,6 +2257,7 @@
 {
 	struct socket *so = kn->kn_fp->f_data;
 
+	/* Unlocked read. */
 	kn->kn_data = so->so_qlen;
 	return (! TAILQ_EMPTY(&so->so_comp));
 }
